# Componentencatalogus

In this application we use the [Django](https://www.djangoproject.com/) for the API and [React](https://reactjs.org/) for the frontend.


## Deployment and release

The [CI system of GitLab](https://gitlab.com/commonground/appstore/pipelines) automatically builds every push to the master branch, creates Docker images and pushes them to the GitLab registry. When a release is successful, it deploys with a manual trigger from within GitLab to the production environment.


## Setup your development environment

First make sure the following tools are available on your computer:

* [Git](https://git-scm.com/)
* [Docker](https://www.docker.com/)
* [Node.js](https://nodejs.org/) (with NPM)
* [Python 3.8](https://www.python.org)


### Then clone this repository

```bash
git clone git@gitlab.com:commonground/appstore/appstore.git
cd appstore/
```


## Start developing

When you run the commands below for the first time, it will take longer because all
dependencies are downloaded.


### Running the services

The Componentencatalogus uses a Postgres database for data storage and Dex (openID Connect) for user
authentication. You can launch these two services using Docker Compose.

```bash
docker-compose -f docker-compose.dev.yaml up -d
```

> The `-d` flag makes it run in the background. To stop the services simply type: `docker-compose stop`


### API

We use [pip-tools](https://github.com/jazzband/pip-tools) for pinning the dependencies.

First setup the environment of the API with:

```bash
cd api/
python3 -m venv .venv
source .venv/bin/activate
pip install pip-tools
pip-sync requirements.txt requirements-dev.txt
```

Then run the database migrations with:

```bash
python manage.py migrate
```

(Optionally) load the test data with:

```bash
python manage.py loaddata fixtures/testdata.json
```

Be aware if you do not load the test data, you will have to assign permissions to users manually.
After an initial login, permissions can be set as follows:

```bash
python manage.py shell
```

```python
from core.models import User
user = User.objects.get(email="admin@example.com")
user.is_admin = True
user.save()
quit()
```

And start the API with:

```bash
python manage.py runserver
```


#### Managing dependencies

Run `pip-compile` after a change in one of the `requirements.in` files. Keep in mind to run it for both the files:

```bash
pip-compile requirements.in
pip-compile requirements-dev.in
```

> Note: Only change the `requirements.in` or `requirements-dev.in`. Not the corresponding `.txt` files, those are generated by `pip-compile`.


### Frontend

```bash
cd ui/ && npm install && npm start
```

This command should automatically open a browser that loads the frontend that is running
on [http://localhost:3000](http://localhost:3000/). The frontend automatically proxies requests
to the Django admin panel through [http://localhost:3000/admin/](http://localhost:3000/admin/).


### E2E-tests

```bash
cd e2e-tests/ && npm install
```

Running the tests on your locally installed browsers:

```bash
npm run test:local
```

Running the tests on BrowserStack:

```bash
npm run test:browserstack
```

> Note: `BROWSERSTACK_USERNAME` and `BROWSERSTACK_ACCESS_KEY` must be specified in order
> to be able to connect with BrowserStack.


## Logging in

Docker Compose runs Dex as the OpenID Connect provider. During development, the following default users are available:

- E-mail: admin@example.com
  Password: password
  Role: admin
- E-mail: po@example.com
  Password: password
  Role: product owner


## Testing

### API

```bash
cd api/ && python manage.py test
```

### UI

```bash
cd ui/ && npm test
```


## Local deployment

## Setup a local Kubernetes environment with minikube

Please make sure you setup [minikube](https://github.com/kubernetes/minikube) and [Helm](https://helm.sh/) on the cluster.

Let's start Minikube first:

```bash
minikube start
```

Load the stable Helm and Appscode repo if you have not done this already:

```bash
helm repo add stable https://kubernetes-charts.storage.googleapis.com/
helm repo add appscode https://charts.appscode.com/stable/
helm repo update
```

Then make sure you have a Traefik ingress controller up and running:

```bash
helm upgrade --install --namespace kube-system --values helm/traefik-values-minikube.yaml traefik stable/traefik
```

Then install KubeDB:

```bash
# Step 1: Install the KubeDB operator chart
helm upgrade --install --namespace kube-system --version v0.13.0-rc.0 kubedb-operator appscode/kubedb

# Step 2: Wait until the crds are registered
kubectl get crds -l app=kubedb -w

# Step 3: Install the KubeDB catalog
helm upgrade --install --namespace kube-system --version v0.13.0-rc.0 kubedb-catalog appscode/kubedb-catalog
```

Now we point `cgas.minikube` to the minikube cluster by running:

```bash
echo "$(minikube ip) cgas.minikube" | sudo tee -a /etc/hosts
```

Now load the Minikube environment variables into the shell to build the Docker images on Minikube:

```bash
eval $(minikube docker-env)
```

Then run the following command from the root of the repository to build the application:

```bash
IMAGE_PREFIX=commonground/appstore/appstore/ IMAGE_TAG=latest docker-compose build --parallel
```

Finally deploy it to the local cluster with:

```bash
kubectl create namespace cgas-dev
helm upgrade --install \
    --namespace cgas-dev \
    --values helm/cgas/values-minikube.yaml \
    cgas-dev ./helm/cgas
```

You will find the application running in the `cgas-dev` namespace. Point your browser to [http://appstore.minikube](http://appstore.minikube) to view the deployment.


## Adding changes

###  Conventions for commit messages
We follow the [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/) specification. This is enforced with a linter in the build pipeline. This convention requires you to pas a type and an optional scope as the commit message. The scope is based on the applications in the repository. If you are not sure which scope to use please leave the scope empty.

The type must be one of the following:

- **build**: Changes that affect the build system or external dependencies
- **ci**: Changes to our CI configuration files and scripts
- **docs**: Documentation only changes
- **feat**: A new feature
- **fix**: A bug fix
- **perf**: A code change that improves performance
- **refactor**: A code change that neither fixes a bug nor adds a feature
- **revert**: Changes that revert other changes
- **style**: Changes that do not affect the meaning of the code (white-space, formatting, missing semi-colons, etc)
- **test**: Adding missing tests or correcting existing tests

The available scopes are:

- api
- helm
- ui

### Review

When a branch begins with `review/` a review app is created for that branch. This app can be used to inspect UI changes of the Merge Request.
